function initProfiles(source) {
	var ptitles = jQuery('#ja-' + source + '-content .ja-profile-titles li.ja-profile');

	//load profile
	ptitles.each(function () {
		var el = jQuery(this);
		var isActive = el.hasClass('active');
		if (isActive) {
			jaEditProfile(source, el.attr('rel'));
		}
		el.on('click', function () {
			changeProfile(source, el, false);
		});
	});

	//profile actions
	jQuery('#ja-' + source + '-content span.ja-profile-action').on('click', function (e) {
		var el = jQuery(this);
		if (el.parent().hasClass('active')) {
			var profile = el.attr('rel');
			var offset = jQuery('#ja-profile-' + source + '-' + profile).offset();
			jQuery('#ja-profile-action').css({
				'display': 'inline',
				'top': offset.top + 20,
				'left': offset.left
			}).attr('rel', source + '|' + profile);
		}
		return false;
	});

	jQuery('#jform_params_' + source + '_target').trigger('change');
	if (jQuery('#jform_params_' + source + '_title_type').length) {
		jQuery('jform_params_' + source + '_title_type').trigger('change');
	}
	if (jQuery('#jform_params_' + source + '_account_type').length) {
		jQuery('#jform_params_' + source + '_account_type').trigger('change');
	}
	if (jQuery('jform_params_' + source + '_getimg').length) {
		jQuery('jform_params_' + source + '_getimg').trigger('change');
	}
	if (jQuery('jform_params_' + source + '_intro_text').length) {
		jQuery('jform_params_' + source + '_intro_text').trigger('change');
	}
}

function resetProfileForm(source) {
	jQuery('#jform_params_' + source + '_account').val('');
}

function changeProfile(source, obj, isdefault) {
	var lis = jQuery('#ja-' + source + '-content .ja-profile-titles li.ja-profile');
	lis.removeClass('active');
	obj.addClass('active');
	jaEditProfile(source, obj.find('.ja-profile-title').attr('rel'));
}

function jaNewProfile(source, obj) {
	var profile = prompt('Please enter profile name', '');
	if (profile) {
		jQuery.ajax({
			method: 'get',
			url: plugin_admin_url + '?jatask=new_profile&profile_source=' + source + '&profile=' + profile,
			dataType: 'json',
			success: function (response) {
				var obj = response || {};

				if (obj.status == 'error') {
					alert(obj.message);
					return false;
				} else if (obj.status == 'success') {
					//alert(obj.message);
					var result = obj.result;

					var source = result.source;
					var profile = result.profile;

					resetProfileForm(source);
					for (var key in result.data) {
						var value = result.data[key];
						if (jQuery('#jform_params_' + key).length) {
							jQuery('#jform_params_' + key).val(value);
						}
					}

					var listPro = jQuery('#list-profiles-' + source);
					listPro.find('li.active').removeClass('active');

					var li = jQuery('<li>', {
						'id': 'ja-profile-' + source + '-' + profile,
						'class': 'ja-profile active',
						'rel': result.profile
					});

					li.on('click', function () {
						changeProfile(source, li, false);
					});

					var stitle = jQuery('<span>', {
						'class': 'ja-profile-title',
						'rel': result.profile,
						'html': result.profile
					});

					var saction = jQuery('<span>', {
						'class': 'ja-profile-action',
						'rel': result.profile,
						'html': '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'
					});

					saction.on('click', function (e) {
						var el = jQuery(this);
						if (el.parent().hasClass('active')) {
							var profile = el.attr('rel');
							var offset = jQuery('#ja-profile-' + source + '-' + profile).offset();
							jQuery('#ja-profile-action').css({
								'display': 'inline',
								'top': offset.top + 20,
								'left': offset.left
							}).attr('rel', source + '|' + profile);
						}
						return false;
					});

					li.append(stitle);
					li.append(saction);

					listPro.append(li);

					//change profile
					li.trigger('click');

					return true;
				}
			}
		});
	}
}

function jaEditProfile(source, profile) {

	jQuery('#profile_' + source).val(profile);

	jQuery.ajax({
		method: 'post',
		dataType: 'json',
		url: plugin_admin_url + '?jatask=edit_profile&profile_source=' + source + '&profile=' + profile,
		success: function (response) {
			var obj = response || {};
			if (obj.status == 'error') {
				alert(obj.message);
				return false;
			} else if (obj.status == 'success') {
				var result = obj.result;
				// convert old data to apply joomla "user field"    
				var author = result[source + '_author'];
				result[source + '_created_by_id'] = result[source + '_created_by'];
				delete result[source + '_created_by'];
				if (!author && result[source + '_created_by_id']) {
					jQuery.ajax({
						method: 'get',
						url: plugin_admin_url + '?jatask=get_author&id=' + result[source + '_created_by_id'],
						success: function (response) {
							updateAuthor(source, response);
						}
					});
				} else {
					updateAuthor(source, author);
				}
				resetProfileForm(source);

				for (var key in result) {
					var value = result[key],
						input = jQuery('#jform_params_' + key);
					
					if (input.length) {
						input.data('org-value', value);
						//Joomla 3.0 dropdown box
						if (jQuery('#jform_params_' + key + '_chzn')) {
							var chosen = jQuery('#jform_params_' + key).val(value).trigger("liszt:updated").data('chosen');
							if (chosen) {
								chosen.current_value = value;
							}
						} else {
							jQuery('#jform_params_' + key).val(value);
						}
					}
				}

				if (jQuery('#ja-profile-' + source + '-' + profile).length) {
					//mark as loaded
					jQuery('#ja-profile-' + source + '-' + profile).addClass('loaded');
					//update show/hide elements
					jQuery('#jform_params_' + source + '_target').trigger('change');
					if (jQuery('#jform_params_' + source + '_title_type').length) {
						jQuery('#jform_params_' + source + '_title_type').trigger('change');
					}
					if (jQuery('#jform_params_' + source + '_account_type').length) {
						jQuery('#jform_params_' + source + '_account_type').trigger('change');
					}
					if (jQuery('#jform_params_' + source + '_getimg').length) {
						jQuery('#jform_params_' + source + '_getimg').trigger('change');
					}
					if (jQuery('#jform_params_' + source + '_intro_text').length) {
						jQuery('#jform_params_' + source + '_intro_text').trigger('change');
					}
				}
				var elm = jQuery('#profile_' + source).parents('.top-group');
				updateOriginalValue(elm);
			}
		}
	});
}

function jaDeleteProfile(source, profile) {
	if (!confirm('Are you sure?')) {
		return false;
	}
	jQuery.ajax({
		method: 'get',
			url: plugin_admin_url + '?jatask=delete_profile&profile_source=' + source + '&profile=' + profile,
		dataType: 'json',
		success: function (response) {
			var obj = response || {};

			if (obj.status == 'error') {
				alert(obj.message);
				return false;
			} else if (obj.status == 'success') {
				var result = obj.result;
				var source = result.source;
				var profile = result.profile;

				var id = '#ja-profile-' + source + '-' + profile;
				if (jQuery(id).length) {
					jQuery(id).remove();
				}
				//set first profile as active
				var ptitles = jQuery('#ja-' + source + '-content .ja-profile-titles li.ja-profile').first();
				if (ptitles.length) {
					ptitles.trigger('click');
				}

				return true;
			}
		}
	});
}

function jaSaveProfile(source) {
	//alert(source);
	var profile = jQuery('#profile_' + source).val();
	if (!profile) {
		profile = prompt('Please enter profile name', '');
		if (!profile) {
			return;
		}
	}

	var queryString = jQuery('form[name="adminForm"]').serialize();
	var author = encodeURI(jQuery('#jform_params_' + source + '_created_by').val());
	queryString = queryString + '&' + encodeURI('jform[params][' + source + '_author]') + '=' + author;

	jQuery.ajax({
		method: 'post',
		url: plugin_admin_url + '?jatask=save_profile&profile_source=' + source,
		data: queryString,
		dataType: 'json',
		success: function (response) {
			var obj = response || {};
			alert(obj.message);
		}
	});
}

function jaTestFacebook(pid) {
	var app_id = jQuery('#jform_params_fb_app_id').val();
	var app_secret = jQuery('#jform_params_fb_app_secret').val();
	var limit = jQuery('#jform_params_facebook_limit_post').val();
	var id = jQuery('#' + pid).val();
	var link = 'https://graph.facebook.com/v2.8/' + id + '/posts?fields=attachments,story,permalink_url,id,from{id,name},message,created_time,updated_time,type,link,description,picture&access_token=' + app_id + '|' + app_secret + '&limit=' + limit;
	jQuery('#test_' + pid).attr('href', link);
}

function jaTestTwitter(pid) {
	var id = jQuery('#' + pid).val();
	jQuery('#test_' + pid).attr('href', 'https://twitter.com/#!/search/' + encodeURIComponent(id));
}

function jaTestYoutube(pid) {
	var option = jQuery('#' + pid + '_option_select').val();
	var id = jQuery('#' + pid).val();
	var url = '';
	if (option == 'username') {
		url = "https://youtube.com/feeds/videos.xml?user=" + encodeURIComponent(id);
	} else if (option == 'playlistID') {
		url = "https://youtube.com/feeds/videos.xml?playlist_id=" + encodeURIComponent(id);
	} else if (option == 'channel') {
		url = "https://youtube.com/feeds/videos.xml?channel_id=" + encodeURIComponent(id);
	}

	jQuery('#test_' + pid).attr('href', url);
}

function jaTestVimeo(pid) {
	//user, group, album, channel

	var vtype = jQuery('#' + pid + '_type').val();
	var vid = jQuery('#' + pid).val();
	var url = '';
	switch (vtype) {
		case 'user':
			url = 'http://vimeo.com/api/v2/' + vid + '/all_videos.xml';
			break;
		case 'album':
			url = 'http://vimeo.com/api/v2/album/' + vid + '/videos.xml';
			break;
		case 'group':
			url = 'http://vimeo.com/api/v2/group/' + vid + '/videos.xml';
			break;
		case 'channel':
			url = 'http://vimeo.com/api/v2/channel/' + vid + '/videos.xml';
			break;
	}
	jQuery('#test_' + pid).attr('href', url);
}

function jaTestInstagram(pid) {
	var keyword = jQuery('#' + pid).val();
	var accesstoken = jQuery('#jform_params_insta_accesstoken').val();
	var url = '';
	if (keyword.toUpperCase() == '[POPULAR]') {
		url = "#";
	} else if (keyword.substr(0, 1) == '@') {
		keyword = keyword.substr(1);
		url = 'https://api.instagram.com/v1/users/' + keyword + '/media/recent/?access_token=' + accesstoken;
	} else if (keyword.substr(0, 1) == '#') {
		keyword = keyword.substr(1);
		url = 'https://api.instagram.com/v1/tags/' + keyword + '/media/recent?access_token=' + accesstoken;
	} else {
		url = 'https://www.instagram.com/' + keyword + '/media/';
	}

	jQuery('#test_' + pid).attr('href', url);
}

function jaTestFlickr(pid) {
	var keyword = jQuery('#' + pid).val();
	var ptype = jQuery('#' + pid + '_type').val();
	var id_album = jQuery('#' + pid + '_id_album').val(); // get id album
	var url = 'http://api.flickr.com/services/feeds/photos_public.gne?format=rss2';

	var re = /\d+\@[^\@]+/;
	if (re.test(keyword)) {
		url = url + '&id=' + keyword;
	} else {
		url = url + '&tags=' + keyword;
	}

	switch (ptype) {
		case 'album':
			url = 'http://api.flickr.com/services/feeds/photoset.gne?format=rss2&set=' + id_album + '&nsid=' + keyword + '';
			break;
		case 'favorite':
			url = 'http://api.flickr.com/services/feeds/photos_faves.gne?format=rss2&id=' + keyword;
			break;
	}

	jQuery('#test_' + pid).attr('href', url);
}

function jaTestPinterest(pid) {
	var bid = pid.replace('pinterest_account', 'pinterest_board');
	var board = jQuery('#' + bid).val() ? jQuery('#' + bid).val() : 'feed';
	var id = jQuery('#' + pid).val();
	jQuery('#test_' + pid).attr('href', 'http://www.pinterest.com/' + encodeURIComponent(id) + '/' + board + '.rss');
}

function jaTestRss(pid) {
	if (jQuery('#' + pid).val()) {
		jQuery('#' + pid).attr('href', jQuery('#' + pid).val());
	}
}

function getParentByClassName(el, classname) {
	return jQuery('#' + el).parents(classname);
}

function getCodeInsta() {
	var domain = document.getElementById('jform_params_insta_app_redirect_url').value;
	domain += '?jasocial_feed_cron=1';
	var url = 'https://api.instagram.com/oauth/authorize/?client_id=' + document.getElementById('jform_params_insta_app_client_id').value + '&redirect_uri=' + (domain) + '&response_type=code&scope=basic+public_content';
	window.open(url, '_blank');
}

function updateAuthor(source, author) {
	jQuery('#jform_params_' + source + '_created_by').val(author);
}

function updateOriginalValue(elm) {
	var $inputs = elm.find('input, textarea, select');

	// get origin value
	$inputs.each(function () {
		var $input = jQuery(this),
			$val = $input.attr('type') == 'radio' ? $input.closest('fieldset').find('input:checked').val() : $input.val();
		$input.data('org-value', $val);
	});
	
	$inputs.trigger('change');
}